// C Source File
// Created 25/07/2003; 11:22:53 a.m.
// Jos Manuel Vsquez Prez
// gsmanuel@gmail.com

#define NO_CALC_DETECT				// No detectar modelo de calculadora
#define USE_TI89              // Compilar para TI-89
#define USE_TI92PLUS          // Compilar para TI-92 Plus
#define USE_V200              // Compilar para Voyage 200
#define RETURN_VALUE          // Devolver expresin insertada
#define ENABLE_ERROR_RETURN   // Permitir devolver errores al AMS
#define OPTIMIZE_ROM_CALLS    // Usar optimizacin de llamadas a ROM
#define MIN_AMS 101           // Compilar para AMS 1.01 o superior
#define Q 3                   // Margen de desbordamiento
#include <tigcclib.h>         // Incluir todas las cabeceras
#include "masas.h"						// Masas moleculares
#include "mate.h"							// Rutinas matemticas
#include "quimica.h"					// Rutinas qumicas

void balancear(short orden, short tipo);
void pesar(short orden, short tipo);
void resolver(short orden, short n, short a, float b);
void dar(short n);

// Funcin principal. Lee el argumento y decide qu hacer con l.
void _main(void)
{
	short a=0,n=4;
	float b=0;
	ESI argumento=top_estack;
	if (GetArgType(argumento)==END_TAG) ER_throw(TOO_FEW_ARGS_ERROR);
	if (GetArgType(argumento)==POSINT_TAG) n = GetIntArg(argumento);
	if (GetArgType(argumento)==STR_TAG){
		top_estack = argumento--;
		short orden=1,hay_coma=0,hay_flecha=0;
		while (*(--argumento)){
			switch(*argumento){
				case 22:
					if (!hay_flecha) hay_flecha = 1;
					else ER_throw(ER_ARGUMENT);
					orden++;
					break;
				case ',':	hay_coma = 1;
				case '+': orden++;}}
		if (n==3) hay_coma = 1;
		if (GetArgType(--argumento)==POSINT_TAG||GetArgType(argumento)==NEGINT_TAG){
			a = GetIntArg(argumento);
			if (GetArgType(argumento)>=POSINT_TAG&&GetArgType(argumento)<=FLOAT_TAG){
				b = estack_number_to_Float(argumento);
				argumento = next_expression_index(argumento);}
			else ER_throw(TOO_FEW_ARGS_ERROR);}
		if (GetArgType(argumento)!=END_TAG) ER_throw(TOO_MANY_ARGS_ERROR);
		if (!n||n>2){
			if (hay_flecha&&!hay_coma) balancear(orden,n);
			else pesar(orden,hay_flecha);}
		else{
			if (a<=orden&&hay_flecha) resolver(orden,n,a,b);
			else ER_throw(ER_ARGUMENT);}}
	else if (GetArgType(argumento)==END_TAG) dar(n);
		else ER_throw(ER_DATATYPE);
//	ST_helpMsg("gsmanuel@gmail.com");
}

// Balancea la ecuacin qumica.
void balancear(short orden, short tipo)
{
	short matriz[orden+Q][orden],lista[orden+Q],i,j,filas=0;
	for (i=0;i<orden+Q;i++) for (j=0;j<orden;j++) matriz[i][j] = 0;
	interpretar(orden,orden+Q,matriz,lista,&filas,tipo);
	reducir(orden,filas,matriz,tipo);
}

// Encuentra el peso molecular de cada compuesto.
void pesar(short orden, short tipo)
{
	short cota,i,j;
	if (tipo) cota = orden+Q;
	else cota = 3*orden+5;
	short matriz[cota][orden],lista[cota],filas=0;
	for (i=0;i<cota;i++) for (j=0;j<orden;j++) matriz[i][j] = 0;
	interpretar(orden,cota,matriz,lista,&filas,0);
	calcular(orden,matriz,lista,filas);
}

// Encuentra el smbolo y peso de un elemento.
void dar(short n)
{
	if (n<1||n>109) ER_throw(ER_DOMAIN);
	push_END_TAG();
	long elemento = nombre[n];
	elemento = elemento<<16;
	push_Float(masa[n]/1e6);
	retornar((char*)&elemento);
	push_LIST_TAG();
}

// Resuelve la ecuacin estequimtrica de la reaccin.
void resolver(short orden, short n, short a, float b)
{
	ESI argumento = top_estack;
	balancear(orden,1);
	if (GetArgType(top_estack)!=LIST_TAG) return;
	delete_between(argumento,next_expression_index(top_estack));
	ESI inicio = top_estack;
	ponerexp(argumento);
	pesar(orden,1);
	if (GetArgType(top_estack)!=LIST_TAG) return;
	delete_between(inicio,next_expression_index(top_estack));
	push_quantum(MUL_TAG);
	push_END_TAG();
	NG_approxESI(top_estack-1);
	ponerexp(inicio);
	push_LIST_TAG();
	if (!a) return;
	argumento = top_estack-2;
	if (n==2){
		while (GetArgType(argumento)!=END_TAG) argumento = next_expression_index(argumento);
		argumento = argumento-2;}
	short i = 1;
	while (i<a) argumento = next_expression_index(argumento), i++;
	ponerexp(argumento);
	push_quantum(DIV_TAG);
	push_Float(b);
	push_quantum(MUL_TAG);
	NG_approxESI(top_estack);
}