// Header File
// Created 31/12/2004; 12:02:16 pm
// Jos Manuel Vsquez Prez
// gsmanuel@gmail.com

#define NP 3

void normalizar(short orden, short OK);
void interpretar(short orden, short cota, short (*matriz)[orden], short *lista, short *filas, short OK);
void reducir(short orden, short filas, short (*matriz)[orden], short OK);
void calcular(short orden, short (*matriz)[orden], short *lista, short filas);
short buscar(short elemento, short cota, short *filas, short *lista);

// Interpreta la ecuacin, determina los subndices de los elementos presentes.
void interpretar(short orden, short cota, short (*matriz)[orden], short *lista, short *filas, short OK)
{
	short i,j=0,factor=1,signo=1,valor=1,elemento=0,par[NP],n=0;
	BOOL hay_valor=FALSE,hay_error=FALSE,hay_mayus=FALSE;
	unsigned char caracter;
	ESI argumento = top_estack-1;
	while (*(--argumento))
	{
		caracter = *argumento;
		switch (caracter){
			case 'A' ... 'Z':
				elemento = (caracter<<8)+elemento;
				i = buscar(elemento,cota,filas,lista);
				matriz[i][j] = matriz[i][j]+signo*factor*valor;
				valor = 1;
				elemento = 0;
				hay_valor = FALSE;
				hay_mayus = TRUE;
				break;
			case 'a' ... 'z': elemento = caracter;
				break;
			case '0' ... '9':
				if (hay_valor) valor = valor+10*(caracter-'0');
				else valor = caracter-'0', hay_valor = TRUE;
				break;
			case 22: if (OK) signo = -1;
			case '+':
			case ',':
			case 0:
				if (!hay_mayus||n!=0) hay_error = 1;
				valor = 1;
				hay_valor = FALSE;
				hay_mayus = FALSE;
				j++;
				break;
			case ')':
			case ']':
				if (n<NP) par[n] = valor, factor = factor*valor;
				n++;
				valor = 1;
				hay_valor = FALSE;
				break;
			case '(':
			case '[':
				n--;
				if (n>=0) factor = factor/par[n];
				break;
			default: ER_throw(ER_ARGUMENT);}
	}
	if (hay_error) ER_throw(ER_ARGUMENT);
}

// Enlista los elementos de cada compuesto y copia los subndices en la matriz.
short buscar(short elemento, short cota, short *filas, short *lista)
{
	short i = 0;
	while (*filas>i){
		if (elemento==lista[i]) return i;
		i++;}
	if (i>=cota) ER_throw(ER_OVERFLOW);
	lista[i] = elemento;
	(*filas)++;
	return i;
}

// Reduce la matriz de subndices y verifica si existe solucin unica.
void reducir(short orden, short filas, short (*matriz)[orden], short OK)
{
	short rango = orden-filas;
	push_shortint(rango>1?rango:1);
	push_quantum(IDENTITY_TAG);
	push_END_TAG();
	push_shortint(orden);
	push_shortint(rango>1?filas:orden-1);
	push_shortint(rango>1?filas+1:orden);
	push_shortint(1);
	poner(orden,filas,matriz,0);
	push_quantum(RREF_TAG);
	push_quantum(SUBMAT_TAG);
	push_quantum(TRANSPOSE_TAG);
	push_shortint(-1);
	push_quantum(MUL_TAG);
	push_quantum(AUGMENT_TAG);
	if (rango<2) normalizar(orden,OK);
	NG_rationalESI(top_estack);
}

// Normaliza la matriz transformndola en una lista con coeficientes enteros.
void normalizar(short orden, short OK)
{
	short i,tipo;
	unsigned short N = 1;
	push_quantum(MAT2LIST_TAG);
	NG_rationalESI(top_estack);
	ESI argumento = top_estack-1;
	for (i=1;i<orden;i++){
		tipo = GetArgType(argumento);
		if (!GetIntArg(argumento)||tipo==NEGFRAC_TAG||tipo==NEGINT_TAG)
			if (OK){ retornar("Imposible balancear");	return;}
		if (tipo==POSFRAC_TAG||tipo==NEGFRAC_TAG) argumento++, N = mcm(GetIntArg(argumento),N);}
	push_shortint(N);
	push_quantum(MUL_TAG);
}

// Multiplica la matriz de coeficientes con la matriz de masas.
void calcular(short orden, short (*matriz)[orden], short *lista, short filas)
{
	short i,j,hay_nombre;
	long peso[filas][1];
	for (i=0;i<filas;i++){
		hay_nombre = 0;
		for (j=1;j<110;j++) if (lista[i]==nombre[j]){
			peso[i][0] = masa[j];
			hay_nombre = 1;
			break;}
		if (!hay_nombre){ retornar("Elemento desconocido"); return;}}
	poner(filas,1,peso,1);
	poner(orden,filas,matriz,0);
	push_quantum(MUL_TAG);
	push_longint(1000000);
	push_quantum(DIV_TAG);
	push_quantum(MAT2LIST_TAG);
	NG_approxESI(top_estack);
}